<?php
// Fonction de calcul de la largeur d'une chaine de caractères
function get_width ( $str, $sz )
{
  $array = imagettfbbox ($sz, 0, "./vera.ttf",  $str );

  return $array[2] - $array[0];
}

// Définition des variables

// Récupération de nombre de membres dans un fichier
$nbmembre = "3500";
if ($fp = @fopen ('../../../nombre-adherents.txt', "r"))
  {
  $nbmembre = fgets($fp);
  $nbmembre = rtrim ($nbmembre);
  fclose($fp);
  }

// Création de l'image
header("Content-type: image/png");
$largeur_image = 416; // Largeur par défaut
$hauteur_image = 32; // Hauteur par défaut

// Récupération de l'image de fond
$img_bottom = @imagecreatefrompng("progbar_bottom.png");

/* Si pas d'image créer une image blanche par défaut */
if(!$img_bottom)
{
	$img_bottom  = @imagecreatetruecolor($largeur_image, $hauteur_image) // Image de taille 520 x 40
	or die('Impossible de créer une image');
	$bgc = imagecolorallocate($img_bottom, 43, 83, 133); // Bleu April
	imagefilledrectangle($img_bottom, 0, 0, $largeur_image, $hauteur_image, $bgc); // Remplit l'image avec un rectangle bleu
}

// Force l'utilisation de la transparence
//imagealphablending($img_bottom, false); // Supprime le alpha blending
imagesavealpha($img_bottom, true); // save alphablending setting (important)

// Récupération de l'image de la barre de progression
$img_bar = @imagecreatefrompng("progbar_bar.png");
//imagealphablending($img_top, false); // Supprime le alpha blending
//imagesavealpha($img_top, true); // save alphablending setting (important)

// Calcul du décalage pour la barre de progression
$x_shift = ($nbmembre * 400)/5000 + 8;

// Ajoute de l'image de la barre de progression
imagecopy($img_bottom, $img_bar, 0, 0, 0, 0, $x_shift, $hauteur_image);

// Récupération de l'image de la flèche
$img_arrow = @imagecreatefrompng("progbar_arrow.png");

// Ajoute de l'image de la barre de progression
imagecopy($img_bottom, $img_arrow, $x_shift, 0, 0, 0, $largeur_image, $hauteur_image);

// Récupération de l'image de dessus
$img_top = @imagecreatefrompng("progbar_top.png");
//imagealphablending($img_top, false); // Supprime le alpha blending
//imagesavealpha($img_top, true); // save alphablending setting (important)

// Ajoute de l'image du dessus
//imagecopymerge($img_bottom, $img_top, 0, 0, 0, 0, $largeur_image , $hauteur_image , 100);
imagecopy($img_bottom, $img_top, 0, 0, 0, 0, $largeur_image, $hauteur_image);

// Couleur du texte
//$color = imagecolorallocate($img_bottom, 238, 89, 33); // Orange April
$color = imagecolorallocate($img_bottom, 255, 255, 255); // Blanc

// Taille de l'image
// A voir : array getimagesize ( string $filename [, array &$img_bottomageinfo ] )
$largeur_moitie_image = $largeur_image / 2;
$hauteur_moitie_image = $hauteur_image / 2;

//Essai avec la chaine la plus longue
//$string = "00000 membres";
$string = $nbmembre . " adhérents";

// Vérification que la taille de la police est compatible avec la largeur de l'image
$size = 20;
while ( get_width ( $string, $size ) > ($largeur_image - 6) )
	$size--;

// Calcul de la hauteur d'une ligne de texte
$array = imagettfbbox ($size, 0, "./vera.ttf",  $string );
$height = $array[3] - $array[5];
if ($height < 0) $height = -$height ;

// Création de la ligne de texte
$x = $largeur_moitie_image - (get_width ( $string, $size ) / 2);
//$y = $height + $hauteur_moitie_image;
$y = ($hauteur_image - $height) / 2 + $height - 5;
imagettftext ($img_bottom, $size, 0, $x, $y, $color, "./vera.ttf", $string);

// Génération de l'image
imagepng($img_bottom,NULL,0);

// Suppression des images en mémoire
imagedestroy($img_bottom);
imagedestroy($img_top);
imagedestroy($img_bar);
imagedestroy($img_arrow);

?> 
